#include <stdio.h>
#include <stdlib.h>
#include "base.h"

// Factorize a number.

int Usage(char** argv, int errorCode)
{
	cout << "Usage: " << argv[0] << " number" << endl;
	cout << "  number > 0" << endl;
	return errorCode;
}

int main(int argc, char** argv)
{
	if (InitBase() == false)
		return 1;

	static verylong n = 0;

	if (argc < 2)
		return Usage(argv, 1);

	if (zsread(argv[1], &n) == 0)
		return Usage(argv, 1);

	if (zsign(n) <= 0)
		return Usage(argv, 1);

	if (zscompare(n, 1) == 0)
	{
		cout << "1 = 1" << endl;
		return 0;
	}

	trace_level = 5;

	IntList r;
	ushort state = factor(n, 0, 1000000, r);
	if (r.Verify(n) == false)
		return 1;
	cout << "factor returns ";
	print_state(state);
	cout << endl;
	if (state == NumPrime)
	{
		cout << n << " =" << r << endl;
	}
	else
	{
		cout << "Could not completely factorize " << n;
		cout << "." << endl;
		cout << "The known factors are:" << endl;
		cout << r << endl;
		cout << "the last of which is possibly not a prime." << endl;
	}

	return 0;

}

