#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "base.h"

// Searches amicable numbers

int Usage(char** argv, int errorCode)
{
	cout << "Usage: " << argv[0] << " number [flag]" << endl;
	cout << "  number > 1 is where the search starts" << endl;
	cout << "  If flag is present, only one number is tested" << endl;
	return errorCode;
}

int main(int argc, char** argv)
{
	int flag = 0;

	trace_level = 0;

	if (InitBase() == false)
		return 1;

	if (argc < 2)
		return Usage(argv, 1);

        if (argc >= 3)
		flag = atoi(argv[2]);

	verylong n = 0;

	if (zsread(argv[1], &n) == 0 || zscompare(n, 1) <= 0)
		return Usage(argv, 1);

	InitCheckMark(argv[0]);
	if (strcmp(argv[0], "augmented") == 0)
		AugmentedSearch(n, flag);
	else if (strcmp(argv[0], "quasi") == 0)
		QuasiSearch(n, flag);
	else 
		FriendSearch(n, flag);

	return 0;
}

