#include "base.h"

static const int IntArraySize = 1024;
static verylong	intArray[IntArraySize];
static bool	intArrayFree[IntArraySize];
static int	intArrayIndex = 0;

static int	numAlloc = 0;
static int	numFree = 0;

void InitArray()
{
	for (int i = 0; i < IntArraySize; i++)
	{
		intArray[i] = 0;
		intArrayFree[i] = true;
	}

} // InitArray

void IntElem::Create()
{
	int tmpIndex = intArrayIndex;

	while (intArrayFree[intArrayIndex] == false)
	{
		if (++intArrayIndex >= IntArraySize)
			intArrayIndex = 0;
		if (intArrayIndex == tmpIndex)
		{
			// No space left.
			cout << "No free space left in IntArray."
				" Increase IntArraySize." << endl;
			exit(1);
		}
	}

	intArrayFree[intArrayIndex] = false;
	mNum = &intArray[intArrayIndex];
	mNumIndex = intArrayIndex;
	if (++intArrayIndex >= IntArraySize)
		intArrayIndex = 0;

	numAlloc++;

} // Create

IntElem::~IntElem()
{
	intArrayFree[mNumIndex] = true;
	numFree++;
	if (trace_level > 6)
		cout << "~IntElem: numAlloc = " << numAlloc << ", numFree = " << numFree << endl;

} // ~IntElem

