#include <stdio.h>
#include <stdlib.h>
#include "base.h"

// Factorization with Pollard's p-1 method

int main(int argc, char** argv)
{
	InitBase();

	if (argc < 2)
	{
		printf("Usage: %s number\n", argv[0]);
		return 1;
	}

	verylong n = 0;
	if (zsread(argv[1], &n) == 0)
	{
		printf("Usage: %s number\n", argv[0]);
		return 1;
	}

	if (zscompare(n, 1) == 0)
	{
		cout << " 1" << endl;
		return 0;
	}

//	trace_level = 0;
	IntList r;
	ushort state = 0;//pollard(n, 0, 10000, 1000000, r);
	cout << "pollard returns ";
	print_state(state);
	cout << endl;
	if (state == NumPrime)
	{
		cout << r << endl;
	}
	else
	{
		cout << "Could not completely factorize " << n;
		cout << "." << endl;
		cout << "The known factors are:" << endl;
		r.Print();
		cout << endl;
		cout << "the last of which is possibly not a prime." << endl;
	}

	return 0;

}

